<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\Fm00004001TransferirTarefasService;
use FM\Traits\TResponse;

class Fm00004001TransferirTarefasController extends FMCrud {
    use TResponse;

    protected $Fm00004001TransferirTarefasService;

    public function __construct($crudService, $environment, Fm00004001TransferirTarefasService $Fm00004001TransferirTarefasService) {
        parent::__construct($crudService, $environment);
        $this->Fm00004001TransferirTarefasService = $Fm00004001TransferirTarefasService;
    }

    public function listTask(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->Fm00004001TransferirTarefasService->listTask($params);
        $dtsVal = new DataSet("task", $var);
        $response->addDataSet($dtsVal);
    }

    public function infoTask(DTO\Request $request, DTO\Response $response){
        try {
            $data = $this->Fm00004001TransferirTarefasService->infoTask($request->getParameters());
            $this->sendResponse($data, 200);
          } catch (Exception $ex) {
              $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function taskOfTheEmployee(DTO\Request $request, DTO\Response $response){
        try {
            $data = $this->Fm00004001TransferirTarefasService->taskOfTheEmployee($request->getParameters());
            $this->sendResponse($data, 200);
          } catch (Exception $ex) {
              $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function transferTask(DTO\Request $request, DTO\Response $response){
        try {
            $data = $this->Fm00004001TransferirTarefasService->transferTask($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocals(DTO\Request $request, DTO\Response $response) {

        $id = $request->getParameters();

        $locals = $this->Fm00004001TransferirTarefasService->getLocals($id);
        $dtsVal = new DataSet('locals', $locals);
        $response->addDataSet($dtsVal);
    }
    
    public function listChecklistAgend(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $checklistAgend = $this->Fm00004001TransferirTarefasService->listChecklistAgend($params);
        $dtsVal = new DataSet('ChecklistAgends', $checklistAgend);
        $response->addDataSet($dtsVal);
    }
    
    public function innerJoinChecklist(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $checklistAgend = $this->Fm00004001TransferirTarefasService->innerJoinChecklist($params);
        $dtsVal = new DataSet('ChecklistAgends', $checklistAgend);
        $response->addDataSet($dtsVal);
    }
    
    public function updateChecklistAgend(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $changedAttributes = $this->Fm00004001TransferirTarefasService->updateChecklistAgend($params);
        $dtsVal = new DataSet('UpdatedValues', $changedAttributes);
        $response->addDataSet($dtsVal);
    }
}

?>