<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use FM\Traits\TResponse;
use FM\Service\Fm00030000TarefasRecorrentesService;

class Fm00030000TarefasRecorrentesController extends FMCrud{
    protected $Fm00030000TarefasRecorrentesService;
   
    use TResponse;

    public function __construct($crudService, $environment, Fm00030000TarefasRecorrentesService $Fm00030000TarefasRecorrentesService) {
        parent::__construct($crudService, $environment);
        $this->Fm00030000TarefasRecorrentesService = $Fm00030000TarefasRecorrentesService;
    }

    public function insertTarefasRecorrentes(Request $request) {
        try {
            $data = $this->Fm00030000TarefasRecorrentesService->insertTarefasRecorrentes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasRecorrentes() {
        try {
            $data = $this->Fm00030000TarefasRecorrentesService->getTarefasRecorrentes();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function tarefasRecorrentes(Request $request){
        try {
           $dados = $request->getParameters();
            if($dados['TIPO'] == "EDITAR") {
                $result = $this->Fm00030000TarefasRecorrentesService->editarTarefaRecorrente($dados);
            }else {
                $result = $this->Fm00030000TarefasRecorrentesService->mudarStatusTarefaRecorrente($dados);
            }
            $this->Fm00030000TarefasRecorrentesService->getTarefasRecorrentes();
            $this->sendResponse($result, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inativarTarefasRecorrentes(Request $request){
        try {
            $data = $this->Fm00030000TarefasRecorrentesService->inativarTarefasRecorrentes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function recriarTarefasRecorrentes(Request $request){
        try {
            $data = $this->Fm00030000TarefasRecorrentesService->recriarTarefasRecorrentes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRelatoriosConflitos(Request $request){
        try {
           
            $data = $this->Fm00030000TarefasRecorrentesService->getRelatoriosConflitos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function delRegistroRelatorio(Request $request){
        try {
         
            $data = $this->Fm00030000TarefasRecorrentesService->delRegistroRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}
?>