<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\TarefaRecorrenteService;
use FM\Traits\TResponse; 


class TarefaRecorrenteController extends FMCrud{
    
    use TResponse;
    
    protected $TarefaRecorrenteService;
   
    public function __construct($crudService, $environment, TarefaRecorrenteService $TarefaRecorrenteService) {
        parent::__construct($crudService, $environment);
        $this->TarefaRecorrenteService = $TarefaRecorrenteService;
    }
    
    public function getRecorrencias(Request $request, Response $response){
        try {
           
            $data = $this->TarefaRecorrenteService->getTarefaRecorrente($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function tarefaRecorrente(Request $request, Response $response){
        try {
            $dados = $request->getParameters();
            if($dados['TIPO'] == "EDITAR"){
                $result = $this->TarefaRecorrenteService->editarTarefaRecorrente($dados);
            }else {
                $result = $this->TarefaRecorrenteService->mudarStatusTarefaRecorrente($dados);
            }
            $this->TarefaRecorrenteService->getTarefaRecorrente();
            $this->sendResponse($result, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getNameTarefas(Request $request, Response $response){
        try {
            $result = $this->TarefaRecorrenteService->getNameTarefas();
            $this->sendResponse($result, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>