<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class CalendarioFactory {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTarefasCalendario($parametros) {

        $alter = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";
        $std = $this->connection->prepare($alter);
        $std->execute();

        $sql = "SELECT TO_DATE( FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI:SS') DTHORAAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, TO_DATE( FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI:SS') DTHRFINALAGEND,
        FCM_LOCALCLI.DSCORIDLOCAL, MAX(FCM_ATIVIDADE.DSCORIDATIVIDADE) AS CORATIVIDADE, FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                    FROM FCM_CHECKLISTAGEND
                    JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                    JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                    JOIN FCM_ATIVIDADE
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
            WHERE TRUNC (FCM_CHECKLISTAGEND.DTHORAAGEND) BETWEEN TO_DATE( :PERIODOINICIAL, 'DD/MM/YYYY') AND TO_DATE( :PERIODOFINAL, 'DD/MM/YYYY')
                    AND (FCM_LOCALCLI.NRLOCALCLIENTEPAI IN (SELECT FCM_LOCALCLI.NRLOCALCLIENTE FROM FCM_LOCALCLI
                                                                WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI) OR :NRLOCALCLIENTEPAI IS NULL)
                    AND (FCM_CHECKLISTAGEND.NRLOCALCLIENTE = :NRLOCALCLIENTE OR :NRLOCALCLIENTE IS NULL)
                    AND (FCM_LOCALCLI.NRSETOR = :NRSETOR OR :NRSETOR IS NULL)
                    AND (FCM_CHECKLISTAGEND.NRCHECKLIST IN (SELECT FCM_ATIVIDADECHK.NRCHECKLIST
                                                                FROM FCM_ATIVIDADECHK
                                                            WHERE FCM_ATIVIDADECHK.NRATIVIDADE = :NRATIVIDADE) OR :NRATIVIDADE IS NULL)
                    AND (FCM_LOCALCLI.NRTIPOLOCALCLI = :NRTIPOLOCALCLI OR :NRTIPOLOCALCLI IS NULL)
                GROUP BY DTHORAAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, DTHRFINALAGEND, FCM_LOCALCLI.DSCORIDLOCAL, FCM_CHECKLISTAGEND.NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getLocaisCalendario($parametros) {

        $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                             FCM_LOCALCLI.NRSETOR, FCM_LOCALCLI.NRLOCALCLIENTEPAI, FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                       FROM FCM_LOCALCLI
                       JOIN FCM_TIPOLOCALCLI
                         ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                          WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = :IDTIPOLOCALCLI";
  
  
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getSetoresCalendario() {
        
        $sql = "SELECT SECTOR.NRSETOR, SECTOR.NMSETOR, SECTOR.IDATIVO, SECTOR.NRORG, SECTOR.DTINCLUSAO,
                    SECTOR.CDOPERINCLUSAO, SECTOR.NRORGINCLUSAO, SECTOR.DTULTATU, SECTOR.CDOPERULTATU,
                    SECTOR.NRORGULTATU, SECTOR.NRFUNCRESPONSAVEL 
                    FROM FCM_SETOR SECTOR";


        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getAtividadesCalendario() {

        $sql = "SELECT NRATIVIDADE, NMATIVIDADE
                  FROM FCM_ATIVIDADE";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    } 

    public function getTipoDeLocal() {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                 FROM FCM_TIPOLOCALCLI";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    } 
}