<?php

namespace FM\Service;

use FM\Factory\Fm00010000ParametrizacaoGeralFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Fm00010000ParametrizacaoGeralService {

    protected $ParametrizacaoGeralFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (Fm00010000ParametrizacaoGeralFactory $ParametrizacaoGeralFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager) {
        $this->ParametrizacaoGeralFactory   = $ParametrizacaoGeralFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getParametroConflito (){
        return $this->ParametrizacaoGeralFactory->getParametroConflito();
    }
    
    public function postMascara($params){
        $this->connection->beginTransaction();
        
        try {
            $NRORG =  $this->Environment->getNrOrg();
            $CDOPERADOR = $this->Environment->getCdOperador();
           
           
            $param  = array (
           // "NRPARAMGERAL" => $this->newCode->getCodeByTableName("FCM_PARAMGERAL", $NRORG, 1, 10, true),
            "CDOPERULTATU" => $CDOPERADOR,
            "IDVALIDACRIATAREFA" => $params['CONFLITO'],
            "NRPARAMGERAL" => 59,
           );
           
           $this->ParametrizacaoGeralFactory->updateConflitoParametrizacao($param);


           // $dados = array(
            //     "IDOBRIGACDLOCAT" => $params['IDOBRIGACDLOCAT'],
            //     "IDUTILIZAMASCCDLOCAT" => $params['IDUTILIZAMASCCDLOCAT'],
            //     "DSMASCCDLOCAT" => $params['DSMASCCDLOCAT'],
            //     "IDALTERAMASCCDLOCAT" => $params['IDALTERAMASCCDLOCAT'],
            //     "CDOPERULTATU" => $this->Environment->getCdOperador(),
            //     "NRORGINCLUSAO" => $NRORG,
            //     "NRORGULTATU" => $NRORG
            // );

            // $respostaDB = $this->ParametrizacaoGeralFactory->getCountMascara();

            // if(!($respostaDB[0]['QTA'])) {
            //     $dados["NRPARAMGERAL"] = $this->newCode->getCodeByTableName("FCM_PARAMGERAL", $NRORG, 1, 10, true);
            //     $dados["CDOPERINCLUSAO"] = $this->Environment->getCdOperador();
            //     $dados["NRORG"] = $NRORG;
            //     $this->ParametrizacaoGeralFactory->postMascara($dados);

            // } else {
            //     $this->ParametrizacaoGeralFactory->updateMascara($dados);
            // }

             $this->connection->commit();
             //$response = ["OK"];
        }  catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function getMascara() {
         return $this->ParametrizacaoGeralFactory->getMascara();
    }

    // Integração com SM
    public function salvarRelacionamento($parametros) {
        $this->connection->beginTransaction();

        try {
            $NRORG = $this->Environment->getNrOrg();;
            $cdOperador = $this->Environment->getCdOperador(); 
            $contador = array();

            foreach($parametros['ATIVIDADE'] as $item) {
                $retorno = $this->ParametrizacaoGeralFactory->validarItem(array(
                    "NRATIVIDADE"       => $item['NRATIVIDADE'], 
                    "CDSERVORCA"        => $parametros['CDSERVORCA'],
                    "CDTPMEDIDASERV"    => $parametros['CDTPMEDIDASERV']
                ));

                if ($retorno == 0) {
                    $params = array(
                        "NRRELSERVITEMTAR"  => $this->newCode->getCodeByTableName("FCM_PARAMGERAL", $NRORG, 1, 10, true),
                        "NRATIVIDADE"       => $item['NRATIVIDADE'], 
                        "CDSERVORCA"        => $parametros['CDSERVORCA'],
                        "CDTPMEDIDASERV"    => $parametros['CDTPMEDIDASERV'], 
                        "NRORG"             => $NRORG,
                        "NRORGINCLUSAO"     => $NRORG,
                        "CDOPERINCLUSAO"    => $cdOperador
                    );

                    $this->ParametrizacaoGeralFactory->inserirRelacionamento($params);
                } else {
                    array_push($contador, $item['NMATIVIDADE']);
                }
            }
            $this->connection->commit();
            return $contador;

        }  catch(\Exception $e) {
          $this->connection->rollback();
          throw $e;
        }
    }

    public function getRelacionamentoServicoTipoMedida() {
        return $this->ParametrizacaoGeralFactory->getRelacionamentoServicoTipoMedida();
    }

    public function getItensRelacionamentoServicoTipoMedida($parametros) {

        return $this->ParametrizacaoGeralFactory->getItensRelacionamentoServicoTipoMedida(array(
            "CDSERVORCA"        => $parametros['CDSERVORCA'],
            "CDTPMEDIDASERV"    => $parametros['CDTPMEDIDASERV'],
        ));
    }

    public function inativarServicos($parametros) {
        $this->connection->beginTransaction();

        try {

            $NRORG = $this->Environment->getNrOrg();;
            $cdOperador = $this->Environment->getCdOperador(); 

            $this->ParametrizacaoGeralFactory->inativarServicos(array(
                "CDOPERULTATU"      => $cdOperador,
                "NRORGULTATU"       => $NRORG,
                "CDSERVORCA"        => $parametros['NRS'][0]['CDSERVORCA'],
                "CDTPMEDIDASERV"    => $parametros['NRS'][0]['CDTPMEDIDASERV']
            ));

            $this->connection->commit();

        }  catch(\Exception $e) {
          $this->connection->rollback();
          throw $e;
        }
    }

    
}
?>
