<?php

namespace FM\Service;

use FM\Factory\Fm00028003RelatorioTarefasAtrasadasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Fm00028003RelatorioTarefasAtrasadasService {

    protected $connection;
    protected $TarefasAtrasadasFactory;
    protected $FuncionariosHierarqService;
    protected $environment;
    protected $newCode;

    public function __construct(Fm00028003RelatorioTarefasAtrasadasFactory $TarefasAtrasadasFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $environment, NewCode $newCode, EntityManager $entityManager) {
        $this->TarefasAtrasadasFactory      = $TarefasAtrasadasFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getTarefasEmAtraso() {
        $cdoperador = $this->environment->getCdOperador();

        $operadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);
        return $this->TarefasAtrasadasFactory->getTarefasEmAtraso($operadores, $cdoperador);
    }

    public function getVistoriasEmAtraso() {
        $cdoperador = $this->environment->getCdOperador();

        $operadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);
        return $this->TarefasAtrasadasFactory->getVistoriasEmAtraso($operadores, $cdoperador);
    }
}
