<?php

namespace FM\Service;

use FM\Factory\LogTransfergerchkFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class LogTransfergerchkService {

    protected $LogTransfergerchkFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, LogTransfergerchkFactory $LogTransfergerchkFactory, Environment $Environment, NewCode $newCode) {
        $this->connection = $entityManager->getConnection();
        $this->LogTransfergerchkFactory = $LogTransfergerchkFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function insertLogTrasnfer($param){

        $this->connection->beginTransaction();
        
        try {
            $LOGTRANSFGERCHK = $this->newCode->getCodeByTableName("FCM_LOGTRANSFGERCHK",  $this->Environment->getNrOrg(), 1, 10, true);
             $this->LogTransfergerchkFactory->insertLogTrasnfer(array(
                'LOGTRANSFGERCHK' => $LOGTRANSFGERCHK,
                'NRGERENCIAMENTOCHK' => $param["NRGERENCIAMENTOCHK"],
                'CDOPERADORORIGEM' => $param["funcionarioOrigem"],
                'DTHORAAGENDORIG' => substr($param['DTHORAAGEND'],0,-3),
                'CDOPERADORDESTINO' => $param['funcionarioDestino'],
                'DTHORAAGENDDESTINO' => substr($param['DTHORAAGEND'],0,-3),
                'NRORG' =>  $this->Environment->getNrOrg(),
                'CDOPERREALIZATRANSF' => $param['operadorTransfer']
            ));
            $this->connection->commit();

        }  catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
          }
    }
}

?>