<?php
namespace FM\Service;

use FM\Factory\UsuariosFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;

class UsuariosService {

    protected $UsuariosFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (UsuariosFactory $UsuariosFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager) {
        $this->UsuariosFactory              = $UsuariosFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getUsersService(){

        return $this->UsuariosFactory->getUsersFactory();;
    }

     public function usersListService(){
        $operadores = $this->UsuariosFactory->usersListFactory();
        return $operadores;
    }

    public function createUserService($nmfuncionario, $nrperfilacesso, $nrcpffuncionario, $nrrgfuncionario, $dsemailfuncionario, $nrtelfuncionario, $nrsetor, $cdoperador) {

    $this->connection->beginTransaction();
    try {

            $nrrgfuncionario = str_replace('.', '', $nrrgfuncionario);
            $nrcpffuncionario = str_replace('.', '', $nrcpffuncionario);
            $nrcpffuncionario = str_replace('-', '', $nrcpffuncionario);
            $nrtelfuncionario = str_replace('(', '', $nrtelfuncionario);
            $nrtelfuncionario = str_replace(')', '', $nrtelfuncionario);
            $nrtelfuncionario = str_replace('-', '', $nrtelfuncionario);
            $nrtelfuncionario = str_replace(' ', '', $nrtelfuncionario);
        /* ------------------------------- Adicionando na tabela de Funcionários ------------------------------- */
           
            $nrfuncionario = $this->newCode->getCodeByTableName('FCM_FUNCIONARIO',  $this->Environment->getNrOrg(), 1, 10, true); //('tabela, nrorg, ...')
          
            $userInfos = array(
                'NRFUNCIONARIO' => $nrfuncionario,
                'NMFUNCIONARIO' => $nmfuncionario,
                'NRPESSOA' => null,
                'CDOPERADOR' => $cdoperador,
                'NRRGFUNCIONARIO' => $nrrgfuncionario,
                'NRCPFFUNCIONARIO' => $nrcpffuncionario,
                'DSEMAILFUNCIONARIO' => $dsemailfuncionario,
                'HRENTRADAPADR' => null,
                'HRSAIDAPADR' => null,
                'NRORG' => $this->Environment->getNrOrg(),
                'IDATIVO' => 'S',
                'OPERADOR' => $this->Environment->getCdOperador(),
                'IDTURNOFUNCIONARIO' => null,
                'NRTELFUNCIONARIO'   => $nrtelfuncionario,
            );
           $this->UsuariosFactory->createUserFactory($userInfos);

        /* ------------------------------- Adicionando na tabela de relação funcionário-função ------------------------------- */

            $relacfuncperfacess = $this->newCode->getCodeByTableName('FCM_RELACFUNCPERFACESS',  $this->Environment->getNrOrg(), 1, 10, true);

            $relacPosInfos = array(
                'RELACFUNCPERFACESS' => $relacfuncperfacess,
                'NRPERFILACESSO' => $nrperfilacesso,
                'NRFUNCIONARIO' => $nrfuncionario,
                'NRORG' => $this->Environment->getNrOrg(),
                'IDATIVO' => 'S',
                'OPERADOR' => $this->Environment->getCdOperador()
            );
            $this->UsuariosFactory->createRelacPosFactory($relacPosInfos);

        /* ------------------------------- adicionando na tabela de relação funcionário-setor ------------------------------- */


            if ($nrsetor !== null) {
                $nrrelacfuncsetor = $this->newCode->getCodeByTableName('FCM_RELACFUNCSETOR',  $this->Environment->getNrOrg(), 1, 10, true);
                $relacSectorInfos = array(
                    'NRRELACFUNCSETOR' => $nrrelacfuncsetor,
                    'NRSETOR' => $nrsetor,
                    'NRFUNCIONARIO' => $nrfuncionario,
                    'NRORG' => $this->Environment->getNrOrg(),
                    'IDATIVO' => 'S',
                    'OPERADOR' => $this->Environment->getCdOperador()
                );
                $this->UsuariosFactory->createRelacSectorFactory($relacSectorInfos);
            }

            $this->connection->commit();

        }  catch(\Exception $e) {
          $this->connection->rollback();
          throw $e;
        }
    }

    public function getUserInfosService($nrfuncionario){
        $params = array(
            'NRFUNCIONARIO' => $nrfuncionario
        );
        $operadores = $this->UsuariosFactory->getUserInfosFactory($params);
        return $operadores;
    }

    public function updateUserService($nrfuncionario, $nmfuncionario, $nrperfilacesso, $nrcpffuncionario, $nrrgfuncionario, $dsemailfuncionario, $nrtelfuncionario, $nrsetor, $relacfuncperfacess, $nrrelacfuncsetor, $cdoperador) {
        
        $this->connection->beginTransaction();
        
        try {

            $nrrgfuncionario = str_replace('.', '', $nrrgfuncionario);
            $nrcpffuncionario = str_replace('.', '', $nrcpffuncionario);
            $nrcpffuncionario = str_replace('-', '', $nrcpffuncionario);
            $nrtelfuncionario = str_replace('(', '', $nrtelfuncionario);
            $nrtelfuncionario = str_replace(')', '', $nrtelfuncionario);
            $nrtelfuncionario = str_replace('-', '', $nrtelfuncionario);
            $nrtelfuncionario = str_replace(' ', '', $nrtelfuncionario);

            $validParam = array(
                'NRFUNCIONARIO' => $nrfuncionario
            );

            $userInfos = array(
                    'NRFUNCIONARIO' => $nrfuncionario,
                    'NMFUNCIONARIO' => $nmfuncionario,
                    'NRRGFUNCIONARIO' => $nrrgfuncionario,
                    'NRCPFFUNCIONARIO' => $nrcpffuncionario,
                    'DSEMAILFUNCIONARIO' => $dsemailfuncionario,
                    'NRTELFUNCIONARIO'   => $nrtelfuncionario,
                    'CDOPERADOR' => $cdoperador
                );
            $this->UsuariosFactory->updateUserFactory($userInfos);

            /* ------ Editando na tabela de relação funcionário-função ------ */
            $relacPosInfos = array(
                'RELACFUNCPERFACESS' => $relacfuncperfacess,
                'NRPERFILACESSO' => $nrperfilacesso,
                'NRFUNCIONARIO' => $nrfuncionario
            );

            $this->UsuariosFactory->updateRelacPosFactory($relacPosInfos);

            /* ------ Editando na tabela de relação funcionário-setor ------ */

            if ($nrrelacfuncsetor == null) {
                $nrrelacfuncsetor = $this->newCode->getCodeByTableName('FCM_RELACFUNCSETOR',  $this->Environment->getNrOrg(), 1, 10, true);

                $relacSectorInfos = array(
                    'NRRELACFUNCSETOR' => $nrrelacfuncsetor,
                    'NRSETOR' => $nrsetor,
                    'NRFUNCIONARIO' => $nrfuncionario,
                    'NRORG' => $this->Environment->getNrOrg(),
                    'IDATIVO' => 'S',
                    'OPERADOR' => $this->Environment->getCdOperador()
                );
                $this->UsuariosFactory->createRelacSectorFactory($relacSectorInfos);
                
            } else {
                $relacSectorInfos = array(
                    'NRRELACFUNCSETOR' => $nrrelacfuncsetor,
                    'NRSETOR' => $nrsetor,
                    'NRFUNCIONARIO' => $nrfuncionario
                );
                $this->UsuariosFactory->updateRelacSectorFactory($relacSectorInfos);
            }


            $this->connection->commit();

        }  catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteUsersService($params){
        $cont = 0;
        $this->connection->beginTransaction();

        try {
            foreach($params['NRFUNCIONARIO'] as $nr) {
                    $validParm = array (
                        'NRFUNCIONARIO' => $nr
                    );

                    $operadores = $this->UsuariosFactory->validUsersFactory($validParm);
                    $valida = $operadores[0]['VALIDA'];
                    
                    if ($valida == 0) {
                        $validaSetor = $this->UsuariosFactory->validSectorUsersFactory($validParm);
                        $valida = $validaSetor[0]['VALIDA'];
                        
                        if($valida ==0) {
                            $this->UsuariosFactory->inativarUser($validParm);
                        } else {
                            $cont =  $cont + 1;
                        }
                    } else {
                        $cont =  $cont + 1;
                    }
            }

            $this->connection->commit();
            return $cont;
        }  catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function getOperadorService(){
        return $this->UsuariosFactory->getOperadorFactory();
    }


}
?>