CREATE OR REPLACE FUNCTION ARQUIVO_DIC_88(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQUENCIAL IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CONTADOR     IN NUMBER,
   P_CONTTOTAL    IN VARCHAR2) RETURN VARCHAR2
AS
   V_CONTGERAL      NUMBER;
   V_CONTREG        NUMBER;
   V_CONTADOR       NUMBER;
   V_VRDEBITO       NUMBER;
   V_VRCREDITO      NUMBER;
   V_VRTOTALIMP     NUMBER;
   V_STTOTAL        VARCHAR2(4000);
BEGIN
   V_CONTADOR := P_CONTADOR;
   V_CONTREG := 0;

   FOR C_REGISTRO88_03 IN (SELECT ('88'||
                                   '03'||
                                   RPAD('0',13,'0')|| /* Dbito PSDI */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRESTOCRED,0)),'00000000000.00'),'.',''))|| /* Estorno de Crdito */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VROUTRDEBI,0)),'00000000000.00'),'.',''))|| /* Outros Dbitos */
                                   RPAD('0',13,'0')|| /* Crdito Presumido */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRSLDCRANTE,0)),'00000000000.00'),'.',''))|| /* Saldo Credor ICMS Perodo Anterior */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VROUTRCRED,0)),'00000000000.00'),'.',''))|| /* Outros Crditos */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRESTODEBI,0)),'00000000000.00'),'.',''))|| /* Estorno de Dbitos */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRDEDUCAO,0)),'00000000000.00'),'.',''))|| /* Dedues */
                                   RPAD('0',13,'0')|| /* Crdito Utilizado do Imobilizado */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRSALDOCRED,0)),'00000000000.00'),'.',''))|| /* Saldo Credor Acumulado */
                                   RPAD('0',4,'0')|| /* Ano PSDI */
                                   RPAD('0',2,'0')|| /* Ms PSDI */
                                   RPAD(' ',44,' ') ) AS DSARQMAG
                           FROM MAPARECUP MR, MAPAAPURAC MA
                           WHERE MA.CDEMPRESA = P_CDEMPRESA
                             AND MA.CDINSCESTA = P_CDINSCESTA
                             AND MA.CDIMPOSTO = P_CDIMPOSTO
                             AND MA.DTINIPERIODO = P_DTINICIAL
                             AND MA.DTFIMPERIODO = P_DTFINAL
                             AND MA.NRSEQUMAPAPU = MR.NRSEQUMAPAPU) LOOP


      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(V_CONTADOR, 10, '0'), C_REGISTRO88_03.DSARQMAG, P_NRSEQUENCIAL);

      V_CONTREG   := NVL(V_CONTREG,0) + 1;
      V_CONTGERAL := NVL(V_CONTGERAL,0) + 1;
   END LOOP;

   V_CONTREG := 0;

   FOR C_REGISTRO88_05 IN (SELECT ('88'||
                                   '05'||
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRTOTAIMPOS,0)),'00000000000.00'),'.',''))||
                                   RPAD('0',13,'0')|| /* ICMS Substituio Interna */
                                   RPAD('0',13,'0')|| /* ICMS Substituio Interna de Transporte */
                                   RPAD('0',13,'0')|| /* ICMS Antecipao com Encerramento de Fase de Tributao */
                                   RPAD('0',13,'0')|| /* ICMS Antecipao sem Encerramento de Fase de Tributao e com MVA (Margem de Valor Agregado) */
                                   RPAD('0',13,'0')|| /* ICMS Antecipao sem Encerramento de Fase de Tributao e sem MVA (Margem de Valor Agregado) */
                                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRDIFALIQU,0)),'00000000000.00'),'.',''))|| /* ICMS Diferencial de Alquota (Uso ou Consumo) */
                                   RPAD('0',13,'0')|| /* ICMS Diferena de Alquota (Imobili-zado) */
                                   RPAD('0',13,'0')|| /* Valor total com Incentivo do PSDI */
                                   RPAD('0',13,'0')|| /* Estorno do Dbito do ICMS Substi-tuio Tributria Interna */
                                   RPAD('0',13,'0')|| /* Fundo Estadual de Combate a Pobreza */
                                   RPAD(' ',37,' ') ) AS DSARQMAG
                           FROM MAPARECUP MR, MAPAAPURAC MA
                           WHERE MA.CDEMPRESA = P_CDEMPRESA
                             AND MA.CDINSCESTA = P_CDINSCESTA
                             AND MA.CDIMPOSTO = P_CDIMPOSTO
                             AND MA.DTINIPERIODO = P_DTINICIAL
                             AND MA.DTFIMPERIODO = P_DTFINAL
                             AND MA.NRSEQUMAPAPU = MR.NRSEQUMAPAPU) LOOP


      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(V_CONTADOR, 10, '0'), C_REGISTRO88_05.DSARQMAG, P_NRSEQUENCIAL);

      V_CONTREG   := NVL(V_CONTREG,0) + 1;
      V_CONTGERAL := NVL(V_CONTGERAL,0) + 1;
   END LOOP;

   IF V_CONTREG > 0 THEN
      V_STTOTAL := P_CONTTOTAL||'88'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      RETURN(TO_CHAR(LPAD(V_CONTGERAL,10,0))||TO_CHAR(LPAD(V_CONTADOR,10,0))||V_STTOTAL);
   END IF;

   IF V_CONTREG = 0 THEN
      RETURN('0');
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DIC_88','5.30.xxx'); END;
/

